﻿-- ** Meliandah / Animal Species - PIG PACK / 04.03.2019  ** --
-- Version : 1.0
-- Add x8 new pigs !
 
animalSpecies = {};
animalSpecies.animalName = {};
animalSpecies.fillTypeIndex = {};
currentModDirectory = g_modsDirectory.."animalSpecies_rooster/";

function animalSpecies:debug(message)
  print(('### Animal Species : %s'):format(message));
end;

function deepcopy(orig)
    copies = {};
    local orig_type = type(orig);
    local copy;
    if orig_type == 'table' then
        if copies[orig] then
            copy = copies[orig];
        else
            copy = {};
            for orig_key, orig_value in next, orig, nil do
                copy[deepcopy(orig_key, copies)] = deepcopy(orig_value, copies)
            end;
            copies[orig] = copy;
            setmetatable(copy, deepcopy(getmetatable(orig), copies));
        end
    else -- number, string, boolean, etc
        copy = orig;
    end
    return copy;
end

function animalSpecies:rpad(str, len, char)
    if len == nil then len = 15 end
    if char == nil then char = ' ' end
    return animalSpecies:ternary(str ~= nil, string.rep(char, len - #tostring(str)) .. tostring(str), string.rep(char, len));
end
function animalSpecies:lpad(str, len, char)
    if len == nil then len = 15 end
    if char == nil then char = ' ' end
    return animalSpecies:ternary(str ~= nil, tostring(str) .. string.rep(char, len - #tostring(str)), string.rep(char, len));
end
function animalSpecies:ternary(cond, T, F)
    return cond and T or F;--REAL TERNARY IN-SCRIPT
end

function animalSpecies:printAnimalTypes()
  --animalSpecies:debug('printing Animal Manager');
  --DebugUtil.printTableRecursively(g_currentMission.inGameMenu.pageAnimals.animalManager, "-", 0, 5);  
  --animalSpecies:debug('printing animalTypes');
  --DebugUtil.printTableRecursively(g_currentMission.inGameMenu.pageAnimals.animalManager.animals, ".", 0, 10);
  
  animalSpecies:debug(('%s | %s | %s | %s | %s | %s | %s | %s | %s | %s | %s')
    :format(animalSpecies:rpad('type'), animalSpecies:rpad('subTypeName', 25), animalSpecies:rpad('strawPerDay'), animalSpecies:rpad('waterPerDay'),  animalSpecies:rpad('foodPerDay'), 
            animalSpecies:rpad('manurePerDay'), animalSpecies:rpad('liquidManurePerDay'), animalSpecies:rpad('milkPerDay'), animalSpecies:rpad('palletsPerDay'), animalSpecies:rpad('birthRatePerDay'),animalSpecies:rpad('foodSpillagePerDay', 20) ));

  for k,v in pairs(g_currentMission.inGameMenu.pageAnimals.animalManager.animals) do
      --DebugUtil.printTableRecursively(v, ".", 0, 10);
	  for sk,sv in pairs(v.subTypes) do
      animalSpecies:debug(('%s | %s | %s | %s | %s | %s | %s | %s | %s | %s | %s')
        :format(animalSpecies:rpad(v.class), animalSpecies:rpad(sv.subTypeName, 25), animalSpecies:rpad(sv.input.strawPerDay), animalSpecies:rpad(sv.input.waterPerDay),  animalSpecies:rpad(sv.input.foodPerDay), 
                animalSpecies:rpad(sv.output.manurePerDay), animalSpecies:rpad(sv.output.liquidManurePerDay), animalSpecies:rpad(sv.output.milkPerDay), animalSpecies:rpad(sv.output.palletsPerDay), animalSpecies:rpad(sv.breeding.birthRatePerDay),animalSpecies:rpad(sv.output.foodSpillagePerDay, 20)));
	  end;
  end;
end;

function animalSpecies:updateAnimalTypes()
    for k,v in pairs(g_currentMission.inGameMenu.pageAnimals.animalManager.animals) do
      --DebugUtil.printTableRecursively(v, "-", 5, 10);
      
      for sk,sv in pairs(v.subTypes) do
      
      if sv.fillTypeDesc.name == 'PIG_TYPE_RED' then                                
                --KEEP NEUTRAL 
                --MAKE x50 BREEDER
                customPig = deepcopy(sv);
                customPig.fillTypeDesc.name = "PIG_TYPE_RED_BREEDER";
                customPig.fillTypeDesc.index = animalSpecies.fillTypeIndex["PIG_TYPE_RED_BREEDER"];
                customPig.fillType = customPig.fillTypeDesc.index;
                customPig.storeInfo.shopItemName = ('%s - x50 (more breeding)'):format(sv.storeInfo.shopItemName);
                customPig.subTypeName = customPig.storeInfo.shopItemName;
                --DATAS
                customPig.input.foodPerDay = 90 * 50.0;
                customPig.input.waterPerDay = 20 * 50.0;
                customPig.output.manurePerDay = 75 * 50.00;
                customPig.output.liquidManurePerDay = 95 * 50.00;
                customPig.input.strawPerDay = 30 * 50.0;         
                customPig.storeInfo.buyPrice = 80000.0;
                customPig.storeInfo.transportPrice = 25000.0;
                customPig.storeInfo.sellPrice = 37500.0;
                customPig.breeding.birthRatePerDay = 0.165 * 0.85;
                --INDEX SUBTYPEID
                table.insert( v.subTypes, customPig );
                for newSubTypeIndex,cust in pairs(v.subTypes) do
                    if cust.fillTypeDesc.name == "PIG_TYPE_RED_BREEDER" then
                        customPig.subTypeId = newSubTypeIndex;
                        cust.subTypeId = newSubTypeIndex;
                    
                         --insert into animal index
                         table.insert( g_currentMission.inGameMenu.pageAnimals.animalManager.indexToAnimal, customPig );
                         for indexIndex,animalIndex in pairs( g_currentMission.inGameMenu.pageAnimals.animalManager.indexToAnimal ) do
                            if animalIndex.fillTypeDesc.name == customPig.fillTypeDesc.name then
                                customPig.index = indexIndex;
                                animalIndex.index = indexIndex;
                                cust.index = indexIndex;                                
                            end
                         end
                        g_currentMission.inGameMenu.pageAnimals.animalManager.fillTypeToAnimal[animalSpecies.fillTypeIndex["PIG_TYPE_RED_BREEDER"]] = deepcopy(cust);
                    end
                end
                
                --MAKE x50 MANURE
                customPig = deepcopy(sv);
                customPig.fillTypeDesc.name = "PIG_TYPE_RED_MANURE";
                customPig.fillTypeDesc.index = animalSpecies.fillTypeIndex["PIG_TYPE_RED_MANURE"];
                customPig.fillType = customPig.fillTypeDesc.index;
                customPig.storeInfo.shopItemName = ('%s - x50 (more manure)'):format(sv.storeInfo.shopItemName);
                customPig.subTypeName = customPig.storeInfo.shopItemName;
                --DATAS
                customPig.input.foodPerDay = 90 * 50.0;
                customPig.input.waterPerDay = 20 * 50.0;
                customPig.output.manurePerDay = 75 * 60.0;
                customPig.output.liquidManurePerDay = 95 * 60.0;
                customPig.input.strawPerDay = 30 * 50.0;         
                customPig.storeInfo.buyPrice = 80000.0;
                customPig.storeInfo.transportPrice = 25000.0;
                customPig.storeInfo.sellPrice = 37500.0;
                customPig.breeding.birthRatePerDay = 0.165 * 0.4;
                --INDEX SUBTYPEID
                table.insert( v.subTypes, customPig );
                for newSubTypeIndex,cust in pairs(v.subTypes) do
                    if cust.fillTypeDesc.name == "PIG_TYPE_RED_MANURE" then
                        customPig.subTypeId = newSubTypeIndex;
                        cust.subTypeId = newSubTypeIndex;
                    
                         --insert into animal index
                         table.insert( g_currentMission.inGameMenu.pageAnimals.animalManager.indexToAnimal, customPig );
                         for indexIndex,animalIndex in pairs( g_currentMission.inGameMenu.pageAnimals.animalManager.indexToAnimal ) do
                            if animalIndex.fillTypeDesc.name == customPig.fillTypeDesc.name then
                                customPig.index = indexIndex;
                                animalIndex.index = indexIndex;
                                cust.index = indexIndex;                                
                            end
                         end
                        
                        g_currentMission.inGameMenu.pageAnimals.animalManager.fillTypeToAnimal[animalSpecies.fillTypeIndex["PIG_TYPE_RED_MANURE"]] = deepcopy(cust);
                    end
                end       
      end;
      
      if sv.fillTypeDesc.name == 'PIG_TYPE_WHITE' then
                --MAKE x5 BREEDER
                customPig = deepcopy(sv);
                customPig.fillTypeDesc.name = "PIG_TYPE_WHITE_BREEDER";
                customPig.fillTypeDesc.index = animalSpecies.fillTypeIndex["PIG_TYPE_WHITE_BREEDER"];
                customPig.fillType = customPig.fillTypeDesc.index;
                customPig.storeInfo.shopItemName = ('%s - x5 (more breeding)'):format(sv.storeInfo.shopItemName);
                customPig.subTypeName = customPig.storeInfo.shopItemName;
                --DATAS
                customPig.input.foodPerDay = 90 * 5.0;
                customPig.input.waterPerDay = 20 * 5.0;
                customPig.output.manurePerDay = 75 * 5.00;
                customPig.output.liquidManurePerDay = 95 * 5.00;
                customPig.input.strawPerDay = 30 * 5.0;         
                customPig.storeInfo.buyPrice = 8500.0;
                customPig.storeInfo.transportPrice = 2250.0;
                customPig.storeInfo.sellPrice = 3500.0;
                customPig.breeding.birthRatePerDay = 0.165 * 1.25;
                --INDEX SUBTYPEID
                table.insert( v.subTypes, customPig );
                for newSubTypeIndex,cust in pairs(v.subTypes) do
                    if cust.fillTypeDesc.name == "PIG_TYPE_WHITE_BREEDER" then
                        customPig.subTypeId = newSubTypeIndex;
                        cust.subTypeId = newSubTypeIndex;
                    
                         --insert into animal index
                         table.insert( g_currentMission.inGameMenu.pageAnimals.animalManager.indexToAnimal, customPig );
                         for indexIndex,animalIndex in pairs( g_currentMission.inGameMenu.pageAnimals.animalManager.indexToAnimal ) do
                            if animalIndex.fillTypeDesc.name == customPig.fillTypeDesc.name then
                                customPig.index = indexIndex;
                                animalIndex.index = indexIndex;
                                cust.index = indexIndex;                                
                            end
                         end
                        
                        g_currentMission.inGameMenu.pageAnimals.animalManager.fillTypeToAnimal[animalSpecies.fillTypeIndex["PIG_TYPE_WHITE_BREEDER"]] = deepcopy(cust);
                    end
                end
                
                --MAKE x5 MANURE                
                customPig_2 = deepcopy(sv);
                customPig_2.fillTypeDesc.name = "PIG_TYPE_WHITE_MANURE";
                customPig_2.fillTypeDesc.index = animalSpecies.fillTypeIndex["PIG_TYPE_WHITE_MANURE"];
                customPig_2.fillType = customPig_2.fillTypeDesc.index;
                customPig_2.storeInfo.shopItemName = ('%s - x5 (more manure)'):format(sv.storeInfo.shopItemName);
                customPig_2.subTypeName = customPig_2.storeInfo.shopItemName;
                
                customPig_2.input.foodPerDay = 90 * 5.0;
                customPig_2.input.waterPerDay = 20 * 5.0;
                customPig_2.output.manurePerDay = 75 * 6.5;
                customPig_2.output.liquidManurePerDay = 95 * 6.5;
                customPig_2.input.strawPerDay = 30 * 5.0;         
                customPig_2.storeInfo.buyPrice = 7500.0;
                customPig_2.storeInfo.transportPrice = 2250.0;
                customPig_2.storeInfo.sellPrice = 3500.0;
                customPig_2.breeding.birthRatePerDay = 0.165 * 0.5;
                
                table.insert( v.subTypes, customPig_2 );
                for newSubTypeIndex2,customType in pairs(v.subTypes) do
                    if customType.fillTypeDesc.name == "PIG_TYPE_WHITE_MANURE" then
                        customPig_2.subTypeId = newSubTypeIndex2;
                        customType.subTypeId = newSubTypeIndex2;
                    
                        
                         table.insert( g_currentMission.inGameMenu.pageAnimals.animalManager.indexToAnimal, customPig_2 );
                         for indexIndex2,animalIndex2 in pairs( g_currentMission.inGameMenu.pageAnimals.animalManager.indexToAnimal ) do
                            if animalIndex2.fillTypeDesc.name == customPig_2.fillTypeDesc.name then
                                customPig_2.index = indexIndex2;
                                animalIndex2.index = indexIndex2;
                                customType.index = indexIndex2;                                
                            end
                         end
                    end
                    g_currentMission.inGameMenu.pageAnimals.animalManager.fillTypeToAnimal[animalSpecies.fillTypeIndex['PIG_TYPE_WHITE_MANURE']] = deepcopy(customType);
                end
      end
      
      if sv.fillTypeDesc.name == 'PIG_TYPE_BLACK_WHITE' then
                --MAKE x10 BREEDER
                customPig = deepcopy(sv);
                customPig.fillTypeDesc.name = "PIG_TYPE_BLACK_WHITE_BREEDER";
                customPig.fillTypeDesc.index = animalSpecies.fillTypeIndex["PIG_TYPE_BLACK_WHITE_BREEDER"];
                customPig.fillType = customPig.fillTypeDesc.index;
                customPig.storeInfo.shopItemName = ('%s - x10 (more breeding)'):format(sv.storeInfo.shopItemName);
                customPig.subTypeName = customPig.storeInfo.shopItemName;
                --DATAS
                customPig.input.foodPerDay = 90 * 10.0;
                customPig.input.waterPerDay = 20 * 10.0;
                customPig.output.manurePerDay = 75 * 10.00;
                customPig.output.liquidManurePerDay = 95 * 10.00;
                customPig.input.strawPerDay = 30 * 10.0;         
                customPig.storeInfo.buyPrice = 16000.0;
                customPig.storeInfo.transportPrice = 5000.0;
                customPig.storeInfo.sellPrice = 7500.0;
                customPig.breeding.birthRatePerDay = 0.165 * 1.0;
                --INDEX SUBTYPEID
                table.insert( v.subTypes, customPig );
                for newSubTypeIndex,cust in pairs(v.subTypes) do
                    if cust.fillTypeDesc.name == "PIG_TYPE_BLACK_WHITE_BREEDER" then
                        customPig.subTypeId = newSubTypeIndex;
                        cust.subTypeId = newSubTypeIndex;
                    
                         --insert into animal index
                         table.insert( g_currentMission.inGameMenu.pageAnimals.animalManager.indexToAnimal, customPig );
                         for indexIndex,animalIndex in pairs( g_currentMission.inGameMenu.pageAnimals.animalManager.indexToAnimal ) do
                            if animalIndex.fillTypeDesc.name == customPig.fillTypeDesc.name then
                                customPig.index = indexIndex;
                                animalIndex.index = indexIndex;
                                cust.index = indexIndex;                                
                            end
                         end
                        
                        g_currentMission.inGameMenu.pageAnimals.animalManager.fillTypeToAnimal[animalSpecies.fillTypeIndex["PIG_TYPE_BLACK_WHITE_BREEDER"]] = deepcopy(cust);
                    end
                end
                
                --MAKE x10 MANURE
                customPig = deepcopy(sv);
                customPig.fillTypeDesc.name = "PIG_TYPE_BLACK_WHITE_MANURE";
                customPig.fillTypeDesc.index = animalSpecies.fillTypeIndex["PIG_TYPE_BLACK_WHITE_MANURE"];
                customPig.fillType = customPig.fillTypeDesc.index;
                customPig.storeInfo.shopItemName = ('%s - x10 (more manure)'):format(sv.storeInfo.shopItemName);
                customPig.subTypeName = customPig.storeInfo.shopItemName;
                --DATAS
                customPig.input.foodPerDay = 90 * 10.0;
                customPig.input.waterPerDay = 20 * 10.0;
                customPig.output.manurePerDay = 75 * 12.50;
                customPig.output.liquidManurePerDay = 95 * 12.50;
                customPig.input.strawPerDay = 30 * 10.0;         
                customPig.storeInfo.buyPrice = 16000.0;
                customPig.storeInfo.transportPrice = 5000.0;
                customPig.storeInfo.sellPrice = 7500.0;
                customPig.breeding.birthRatePerDay = 0.165 * 0.35;
                --INDEX SUBTYPEID
                table.insert( v.subTypes, customPig );
                for newSubTypeIndex,cust in pairs(v.subTypes) do
                    if cust.fillTypeDesc.name == "PIG_TYPE_BLACK_WHITE_MANURE" then
                        customPig.subTypeId = newSubTypeIndex;
                        cust.subTypeId = newSubTypeIndex;
                    
                         --insert into animal index
                         table.insert( g_currentMission.inGameMenu.pageAnimals.animalManager.indexToAnimal, customPig );
                         for indexIndex,animalIndex in pairs( g_currentMission.inGameMenu.pageAnimals.animalManager.indexToAnimal ) do
                            if animalIndex.fillTypeDesc.name == customPig.fillTypeDesc.name then
                                customPig.index = indexIndex;
                                animalIndex.index = indexIndex;
                                cust.index = indexIndex;                                
                            end
                         end
                        
                        g_currentMission.inGameMenu.pageAnimals.animalManager.fillTypeToAnimal[animalSpecies.fillTypeIndex["PIG_TYPE_BLACK_WHITE_MANURE"]] = deepcopy(cust);
                    end
                end
      end;
      
      if sv.fillTypeDesc.name == 'PIG_TYPE_BLACK' then
                --MAKE x100 BREEDER
                customPig = deepcopy(sv);
                customPig.fillTypeDesc.name = "PIG_TYPE_BLACK_BREEDER";
                customPig.fillTypeDesc.index = animalSpecies.fillTypeIndex["PIG_TYPE_BLACK_BREEDER"];
                customPig.fillType = customPig.fillTypeDesc.index;
                customPig.storeInfo.shopItemName = ('%s - x100 (more breeding)'):format(sv.storeInfo.shopItemName);
                customPig.subTypeName = customPig.storeInfo.shopItemName;
                --DATAS
                customPig.input.foodPerDay = 90 * 100.0;
                customPig.input.waterPerDay = 20 * 100.0;
                customPig.output.manurePerDay = 75 * 100.00;
                customPig.output.liquidManurePerDay = 95 * 100.00;
                customPig.input.strawPerDay = 30 * 100.0;         
                customPig.storeInfo.buyPrice = 165000.0;
                customPig.storeInfo.transportPrice = 50000.0;
                customPig.storeInfo.sellPrice = 75000.0;
                customPig.breeding.birthRatePerDay = 0.165 * 0.7;
                --INDEX SUBTYPEID
                table.insert( v.subTypes, customPig );
                for newSubTypeIndex,cust in pairs(v.subTypes) do
                    if cust.fillTypeDesc.name == "PIG_TYPE_BLACK_BREEDER" then
                        customPig.subTypeId = newSubTypeIndex;
                        cust.subTypeId = newSubTypeIndex;
                    
                         --insert into animal index
                         table.insert( g_currentMission.inGameMenu.pageAnimals.animalManager.indexToAnimal, customPig );
                         for indexIndex,animalIndex in pairs( g_currentMission.inGameMenu.pageAnimals.animalManager.indexToAnimal ) do
                            if animalIndex.fillTypeDesc.name == customPig.fillTypeDesc.name then
                                customPig.index = indexIndex;
                                animalIndex.index = indexIndex;
                                cust.index = indexIndex;                                
                            end
                         end
                        
                        g_currentMission.inGameMenu.pageAnimals.animalManager.fillTypeToAnimal[animalSpecies.fillTypeIndex["PIG_TYPE_BLACK_BREEDER"]] = deepcopy(cust);
                    end
                end
                
                --MAKE x100 MANURE
                customPig = deepcopy(sv);
                customPig.fillTypeDesc.name = "PIG_TYPE_BLACK_MANURE";
                customPig.fillTypeDesc.index = animalSpecies.fillTypeIndex["PIG_TYPE_BLACK_MANURE"];
                customPig.fillType = customPig.fillTypeDesc.index;
                customPig.storeInfo.shopItemName = ('%s - x100 (more manure)'):format(sv.storeInfo.shopItemName);
                customPig.subTypeName = customPig.storeInfo.shopItemName;
                --DATAS
                customPig.input.foodPerDay = 90 * 100.0;
                customPig.input.waterPerDay = 20 * 100.0;
                customPig.output.manurePerDay = 75 * 120.0;
                customPig.output.liquidManurePerDay = 95 * 120.0;
                customPig.input.strawPerDay = 30 * 100.0;         
                customPig.storeInfo.buyPrice = 165000.0;
                customPig.storeInfo.transportPrice = 50000.0;
                customPig.storeInfo.sellPrice = 75000.0;
                customPig.breeding.birthRatePerDay = 0.165 * 0.25;
                --INDEX SUBTYPEID
                table.insert( v.subTypes, customPig );
                for newSubTypeIndex,cust in pairs(v.subTypes) do
                    if cust.fillTypeDesc.name == "PIG_TYPE_BLACK_MANURE" then
                        customPig.subTypeId = newSubTypeIndex;
                        cust.subTypeId = newSubTypeIndex;
                    
                         --insert into animal index
                         table.insert( g_currentMission.inGameMenu.pageAnimals.animalManager.indexToAnimal, customPig );
                         for indexIndex,animalIndex in pairs( g_currentMission.inGameMenu.pageAnimals.animalManager.indexToAnimal ) do
                            if animalIndex.fillTypeDesc.name == customPig.fillTypeDesc.name then
                                customPig.index = indexIndex;
                                animalIndex.index = indexIndex;
                                cust.index = indexIndex;                                
                            end
                         end
                        
                        g_currentMission.inGameMenu.pageAnimals.animalManager.fillTypeToAnimal[animalSpecies.fillTypeIndex["PIG_TYPE_BLACK_MANURE"]] = deepcopy(cust);
                    end
                end
      end;
    end;
  end;
end;

function animalSpecies:loadMap(name) 
    animalSpecies:addCustomFillType();
    animalSpecies:updateAnimalTypes();
    animalSpecies:printAnimalTypes();   
end;

--ADD CUSTOM FILL TYPE
function animalSpecies:addCustomFillType()
    -- ADD NEW FILL TYPES   
    --WHITE BREEDER
    customWhitePig = deepcopy(g_fillTypeManager.fillTypes[74]);--TAKE FROM WHITE PIG     
    customWhitePig.name = "PIG_TYPE_WHITE_BREEDER";
    animalSpecies:insertFillType( customWhitePig );
    --WHITE MANURE
    customWhitePig_2 = deepcopy(g_fillTypeManager.fillTypes[74]);--TAKE FROM WHITE PIG
    customWhitePig_2.name = "PIG_TYPE_WHITE_MANURE";
    animalSpecies:insertFillType( customWhitePig_2 );
    --BLACK WHITE BREEDER
    customWhitePig = deepcopy(g_fillTypeManager.fillTypes[75]);--TAKE FROM BLACK WHITE PIG     
    customWhitePig.name = "PIG_TYPE_BLACK_WHITE_BREEDER";
    animalSpecies:insertFillType( customWhitePig );
    --BLACK WHITE MANURE
    customWhitePig = deepcopy(g_fillTypeManager.fillTypes[75]);--TAKE FROM BLACK WHITE PIG     
    customWhitePig.name = "PIG_TYPE_BLACK_WHITE_MANURE";
    animalSpecies:insertFillType( customWhitePig );
    --BLACK BREEDER
    customWhitePig = deepcopy(g_fillTypeManager.fillTypes[76]);--TAKE FROM BLACK  PIG     
    customWhitePig.name = "PIG_TYPE_BLACK_BREEDER";
    animalSpecies:insertFillType( customWhitePig );
    --BLACK MANURE
    customWhitePig = deepcopy(g_fillTypeManager.fillTypes[76]);--TAKE FROM BLACK  PIG     
    customWhitePig.name = "PIG_TYPE_BLACK_MANURE";
    animalSpecies:insertFillType( customWhitePig );
    --RED BREEDER
    customWhitePig = deepcopy(g_fillTypeManager.fillTypes[73]);--TAKE FROM red PIG     
    customWhitePig.name = "PIG_TYPE_RED_BREEDER";
    animalSpecies:insertFillType( customWhitePig );
    --RED MANURE  
    customWhitePig = deepcopy(g_fillTypeManager.fillTypes[73]);--TAKE FROM red PIG     
    customWhitePig.name = "PIG_TYPE_RED_MANURE";
    animalSpecies:insertFillType( customWhitePig );  
end;

--INSERT FILL TYPE IN GAME
function animalSpecies:insertFillType( customFillType )
    table.insert( g_fillTypeManager.indexToName, customFillType.name);    
    for index,txt in pairs(g_fillTypeManager.indexToName) do
        if txt == customFillType.name then
            animalSpecies.fillTypeIndex[customFillType.name] = index;
            customFillType.index = index;
            g_fillTypeManager.categoryIndexToFillTypes[16][index] = true;
            g_fillTypeManager.fillTypes[index] = deepcopy(customFillType);
            g_fillTypeManager.nameToIndex[txt] = index;
            g_fillTypeManager.nameToFillType[txt] = deepcopy(customFillType);
        end;
    end;
end;

function animalSpecies:keyEvent(unicode, sym, modifier, isDown)
end;

function animalSpecies:update(dt)
end;

function animalSpecies:draw()
end;

function animalSpecies:deleteMap()
end;

function animalSpecies:mouseEvent(posX, posY, isDown, isUp, button)
end;

addModEventListener(animalSpecies);